function[out]=bhpost(th,s,r);
%%%Function used for generating maximum a posteriri (MAP) estimates of
%'log(alpha)' and 'log(beta)' in the Beverton-Holt (BH) model. This function 
%works under a Matlab built-in function,'fminsearch'.The noise term in the 
%BH model,v,is marginalized analytically.

%%%Function begins from here:
%Arranging data.
%'s' is stock size
%'r' is recruitment
x=1/max(s)*s;
lx=length(x);
y=log(r./s);

%Changing notations in the Ricker model.
%'loga' is 'log(alpha)'.
%'logc' is 'log(beta)'.
loga=th(1);
logc=th(2);

%Joint posterior distribution of 'log(alpha)' and 'log(beta)'.
%'Post' is an unnormalized joint posterior distribution of 'log(alpha)'
%and 'log(beta)'.
ss=sum((y-loga+log(1+x*exp(logc))).^2);
pri=x./(1+x*exp(logc));
pribar=mean(pri);
prior=exp(logc)*(sum((pri-pribar).^2))^(1/2);
al=lx/2;
be=1/2*ss;
Post=be^(-al)*prior;
out=Post;
out=-out;
