function[out]=ricker(th,s,r);
%%%Function used for generating maximum a posteriri (MAP) estimates of
%'log(alpha)' and 'beta' in the Ricker model. This function works under a 
%Matlab built-in function,'fminsearch'.The noise term in the Ricker model,v, 
%is marginalized analytically.

%%%Function begins from here:
%Arranging data.
%'s' is stock size
%'r' is recruitment
x=1/max(s)*s;
lx=length(x);
y=log(r./s);

%Changing notations in the Ricker model.
%'loga' is 'log(alpha)'.
%'b' is 'beta'.
loga=th(1);
b=th(2);

%Joint posterior distribution of 'log(alpha)' and 'beta'.
%'Post' is an unnormalized joint posterior distribution of 'log(alpha)'
%and 'beta'.
ss=sum((y-loga+b*x).^2);
al=lx/2;
be=1/2*ss;
Post=be^(-al);
out=Post;
out=-out;